<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crm00050000RevendaFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function insertParcNegocio($paramsInsertParcNegocio){

        $insert = "INSERT INTO PARCNEGOCIO (NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC, IDATIVO, DTINCLUSAO,
                         NRORGINCLUSAO, CDOPERINCLUSAO, CDTIPOPARCPRINCIPAL, CDTIPOINSCRICAO,IDPESSOAFISICA)
         VALUES (:NRPARCNEGOCIO,
                 :NRORG,
                 :NMPRINCIPALPARC,
                 :NMSECUNDARIPARC,
                 :NRINSCRICAOPARC,
                 :IDATIVO,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :CDTIPOPARCPRINCIPAL,
                 :CDTIPOINSCRICAO,
                 :IDPESSOAFISICA)";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertParcNegocio);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function insertResaleInterloc($paramsInsertResaleInterloc){

        $insert = "INSERT INTO CRM_INTERLOCUTOR (NRSEQINTERLOCUTOR, NMINTERLOCUTOR, NRPARCNEGOCIO,
        NRTELEFONE1, EMAILINTERLOC, NRORG, IDATIVO, DTINCLUSAO, CDOPERINCLUSAO)
         VALUES (:NRSEQINTERLOCUTOR,
                 :NMINTERLOCUTOR,
                 :NRPARCNEGOCIO,
                 :NRTELEFONEINTERLOC,
                 :EMAILINTERLOC,
                 :NRORG,
                 :IDATIVO,
                  SYSDATE,
                 :CDOPERADOR)";
         
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertResaleInterloc);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function insertParceria($paramsInsertParceria){

        $insert = "INSERT INTO PARCERIA (NRPARCNEGOCIO, NRORG, IDATIVO, DTINCLUSAO,
                         NRORGINCLUSAO, CDOPERINCLUSAO, NRPARCERIA, CDTIPOPARCEIRO)
         VALUES (:NRPARCNEGOCIO,
                 :NRORG,
                 :IDATIVO,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :NRPARCERIA,
                 :CDTIPOPARCEIRO
                )";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertParceria);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function insertComunicaparc($paramsInsertComunicaparc){

        $insert = "INSERT INTO COMUNICAPARC (NRPARCNEGOCIO, NRORG, IDATIVO, DTINCLUSAO,
                         NRORGINCLUSAO, CDOPERINCLUSAO, NRCOMUNICAPARC, CDCOMUNICAPARC, CDFORMACOMU)
         VALUES (:NRPARCNEGOCIO,
                 :NRORG,
                 :IDATIVO,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :NRCOMUNICAPARC,
                 :CDCOMUNICAPARC,
                 :CDFORMACOMU
                )";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertComunicaparc);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function insertEndeparc($paramsInsertEndeparc){

        $insert = "INSERT INTO ENDERECOPARC (IDATIVO, NRPARCNEGOCIO, NRORG, NRENDERECOPARC, CDTIPOENDERECO,
                        DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, NMBAIRROENDERECO, DSCOMPLEENDERECO,
                        NRCEPENDERECO, DSENDERECO, NRIMOVELENDERECO)
         VALUES (:IDATIVO,
                 :NRPARCNEGOCIO,
                 :NRORG,
                 :NRENDERECOPARC,
                 :CDTIPOENDERECO,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :CDPAIS,
                 :SGESTADO,
                 :CDMUNICIPIO,
                 :CDBAIRRO,
                 :NMBAIRROENDERECO,
                 :DSCOMPLEENDERECO,
                 :NRCEPENDERECO,
                 :DSENDERECO,
                 :NRIMOVELENDERECO
                )";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertEndeparc);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function insertEndeRevenda($paramsInsertEndeRevenda){
        $insert = "INSERT INTO CRM_ENDEREVENDA (IDATIVO, NRREVENDA, NRORG, CDTIPOENDERECO, NRENDERECOPARC, NRENDEREVENDA,
                        DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, NMBAIRRO, DSCOMPLEREVENDA,
                        NRCEPREVENDA, DSENDEREVENDA, NRNUMEROREVENDA)
         VALUES (:IDATIVO,
                 :NRREVENDA,
                 :NRORG,
                 :CDTIPOENDERECO,
                 :NRENDERECOPARC,
                 :NRENDEREVENDA,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :CDPAIS,
                 :SGESTADO,
                 :CDMUNICIPIO,
                 :CDBAIRRO,
                 :NMBAIRRO,
                 :DSCOMPLEREVENDA,
                 :NRCEPREVENDA,
                 :DSENDEREVENDA,
                 :NRNUMEROREVENDA
                )";

        
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertEndeRevenda);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function insertComunicaRevenda($paramsInsertComunicaRevenda){
        $insert = "INSERT INTO CRM_COMUNICAREVENDA (NRREVENDA, NRCOMUNICAPARC, NRORG, IDATIVO, DTINCLUSAO,
                    NRORGINCLUSAO, CDOPERINCLUSAO, NRCOMUNICAREVENDA, CDCOMUNICACAO, CDFORMACOMU)
         VALUES (:NRREVENDA,
                 :NRCOMUNICAPARC,
                 :NRORG,
                 :IDATIVO,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :NRCOMUNICAREVENDA,
                 :CDCOMUNICACAO,
                 :CDFORMACOMU
                )";  
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertComunicaRevenda);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function updateComunicaRevenda($paramsUpdateComunicaRevenda){
        $Update = "UPDATE CRM_COMUNICAREVENDA SET CDCOMUNICACAO = :CDCOMUNICACAO
                        WHERE NRCOMUNICAREVENDA = :NRCOMUNICAREVENDA AND NRORG = :NRORG AND NRREVENDA = :NRREVENDA";  
        try{
            $std = $this->connection->prepare($Update);
            $std->execute($paramsUpdateComunicaRevenda);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getParcByClient($cdcliente, $nrorg){
        $select = "SELECT NRPARCNEGOCIO FROM CLIENTE WHERE NRORG = '$nrorg' AND CDCLIENTE = '$cdcliente' ";  
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getEndeclie($cdcliente, $nrorg){
        
        $select = "SELECT ENDC.NRENDERECOPARC NRENDERECOPARC, ENDP.CDTIPOENDERECO CDTIPOENDERECO, ENDC.CDPAIS CDPAIS, ENDC.SGESTADO SGESTADO,
                                ENDC.CDMUNICIPIO CDMUNICIPIO, ENDC.CDBAIRRO CDBAIRRO, ENDC.NMBAIRCLIE NMBAIRRO,
                                ENDC.DSCOMPENDCLI DSCOMPLEREVENDA, ENDC.NRCEPCLIE NRCEPREVENDA, DSENDECLIE DSENDEREVENDA
                                FROM ENDECLIE ENDC
                    LEFT JOIN ENDERECOPARC ENDP
                    ON ENDC.NRENDERECOPARC = ENDP.NRENDERECOPARC
                        AND ENDC.NRORG = ENDP.NRORG
                     WHERE ENDP.CDTIPOENDERECO = 'PRINCIPAL'
                            AND ENDC.CDCLIENTE = '".$cdcliente."'
                            AND ENDC.NRORG = ".$nrorg;  
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getComunicaByClient($cdcliente, $nrorg){

        $select = "SELECT COM.NRCOMUNICAPARC NRCOMUNICAPARC, COM.CDCOMUNICAPARC CDCOMUNICAPARC, COM.CDFORMACOMU
                        FROM CLIENTE CLIE
                    LEFT JOIN PARCNEGOCIO PARC
                    ON CLIE.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                        AND CLIE.NRORG = PARC.NRORG
                    LEFT JOIN COMUNICAPARC COM
                    ON COM.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                    AND COM.NRORG = PARC.NRORG
                     WHERE CLIE.CDCLIENTE IN (')
                            AND CLIE.NRORG = '$nrorg'";  
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
     public function getClientByInscription($inscricao, $nrorg){
        $select = "SELECT CDCLIENTE, NMRAZSOCCLIE FROM CLIENTE WHERE NRORG = '$nrorg' AND NRINSJURCLIE = '$inscricao' ";  
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function verifyParceria($nrparcnegocio, $nrorg){
        $select = "SELECT NRPARCNEGOCIO FROM PARCERIA WHERE NRORG = '$nrorg' AND NRPARCNEGOCIO = '$nrparcnegocio' AND CDTIPOPARCEIRO = 'REVENDA' ";  
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            if(empty($std->fetchAll())){
                return false;
            }else{
                return true;
            }
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function verifyComunicaRevenda($cdcomunicacao, $nrorg, $revenda){
        $select = "SELECT NRCOMUNICAREVENDA FROM CRM_COMUNICAREVENDA WHERE NRORG = '$nrorg' AND CDCOMUNICACAO = '$cdcomunicacao' AND NRREVENDA = '$revenda' ";  
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $comunica = $std->fetchAll();
            return $comunica;
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
        
    

}
?>