const fs = require("fs");
const basePath = '/home/developer/workfolder/crm/mobile/assets/';
const subModules = [];

var filePath;
var dir;
var undefinedsCircunstances = [];
var elementsChanged = [];


dir = basePath+'json/containers';
var files = fs.readdirSync(dir);
selectFiles(files);

subModules.forEach(subModule => {
    dir = basePath+'modules\\'+subModule+'\\assets\\json\\containers';
    files = fs.readdirSync(dir);
    selectFiles(files);
});

undefinedsCircunstances = JSON.stringify(undefinedsCircunstances, undefined, 4);
elementsChanged = JSON.stringify(elementsChanged, undefined, 4);
var dirUndefinedCircustancies = basePath+'/undefinedsCircunstances.json';
var dirElementsChanged = basePath+'/elementsChanged.json';
fs.writeFile(dirUndefinedCircustancies, undefinedsCircunstances);
fs.writeFile(dirElementsChanged, elementsChanged);
elementsNotChanged = JSON.parse(undefinedsCircunstances).length;
elemetensChanged = JSON.parse(elementsChanged).length;
console.log(elementsNotChanged + ' elements not changed. Please check the file '+dirUndefinedCircustancies);
console.log(elemetensChanged + ' elements changed. Details in file '+dirElementsChanged);

function selectFiles(files) {
    files.forEach(fileName => {
        if (fileName.indexOf('.json') != -1) {
            readFile(fileName);
        }
    });
}

function readFile(fileName) {
    filePath = dir+'/'+fileName;
    var content = fs.readFileSync(filePath);
    var jsonContent = JSON.parse(content);
    
    
    var result = readObject(jsonContent);
    
    // fs.writeFile('./gen/'+fileName, JSON.stringify(result, undefined, 4));
    fs.writeFile(filePath, JSON.stringify(result, undefined, 4));
}

function readObject(object) {
    if (object.template && object.template == 'field/select.html') {
        return buildSelectAutoComplete(object);
    } else if (object.filterProperties && object.filterProperties.template == 'field/select.html') {
        return undefinedsCircunstancesFunction(object, true, 'template field/select.html in filterProperties');
    } else {
        if (object.fields) {
            readArray(object.fields);
        }
        if (object.widgets) {
            readArray(object.widgets);
        } 
        return object;
    }
}

function readArray(arr) {
    return arr.map(readObject);
}

function buildSelectAutoComplete(element) {
    if (isInConditionToChange(element)) {
        element.template = 'zh-select-autocomplete#field/select-autocomplete.html';

        fieldsNames = getVisibleFieldsNames(element);
        element.searchableFields = [];
        element.displayedFields  = [];
        
        fieldsNames.forEach(function(name){
            element.searchableFields.push(name);  
            element.displayedFields.push(name);
        });
        element.valueField = element.valueField;
        element.descriptionField = element.descriptionField;
        if(element.dataSource)
            element.dataSource.lazyLoad = true;

        undefinedsCircunstancesFunction(element, false, 'done');
    } else {
        
    }
    
    return element;
}   

function undefinedsCircunstancesFunction(element, error, circunstance) {
    var info = {
        "filePath": filePath,
        "elementId": element.id ? element.id : 'not found',
        "elementName": element.name ? element.name : 'not found',
        "circunstance": circunstance ? circunstance : 'circunstance not found'
    };
    if (error) {
        undefinedsCircunstances.push(info);
    } else {
        elementsChanged.push(info);
    }
}

function isInConditionToChange(element) {
    var numberFields = getVisibleFieldsNames(element).length;
    var events = element.events ? element.events : [];
    var isProductField = false;
    var dontHaveDatasource = element.dataSource ? false : true;

    events = events.filter(event => { 
        if (event.name === 'BeforeSelectOpen') {
            return true;
        }
    }).length;
    
    if(numberFields <= 0){
        createFieldsInSelect(element);
        numberFields = 1;
    }

    if (numberFields > 0 && events === 0 && !isProductField) {
        return true;
    } else {
        var message = '';
        if (numberFields <= 0) {
            message += 'element dont contains fields. ';
        }
        if (events !== 0) {
            message += 'element contais event BeforeSelectOpen. ';
        }
        if (isProductField) {
            message += 'element can be product field.';
        }
        if (dontHaveDatasource) {
            message += 'element dont have datasource.';
        }
        undefinedsCircunstancesFunction(element, true, message);
        return false;
    }

}

function createFieldsInSelect(element){
    var fields = [
        {
            id:element.id+'1',
            name:element.name,
            label:element.label,
            isVisible:true,
            showOnList:true,
            template:'field/text-edit.html'
        }
    ];
    element.fields = fields;
}

function getVisibleFieldsNames(element) {
    var fields = [];
    if (element.fields) {
        fields = element.fields.map(field => { return field.name });
    }
    return fields;
}

function isProductFieldFunction(name) {
    if (name.indexOf('PROD') != -1 ) {
        return true;
    } else {
        return false;
    }
}